Changes to bldpkg:

* Moved nopackagebuildfileerror and getbuildfileanddir function to the top
* Added startdate, htmloutput and verifychecksums functions
* Removed compileonlyfor function and replaced it with apparch variable check
* Discarded -v option from set -xv getopts command
* Added autobuildmode check when invoking genchecksum
* Added error messages against several arguments when autobuildmode is set
* Other miscellaneous fixes
This commit is contained in:
PktSurf 2023-05-19 16:45:48 +05:30
parent 64e8468718
commit 83aa14ccba

436
bldpkg
View file

@ -3,7 +3,7 @@
# Part of the SMLinux distribution
# http://git.pktsurf.in/smlinux
#
# /bin/bldpkg version 0.102
# /bin/bldpkg version 0.104
# Bash script to build SMLinux-specific packages
#
# Copyright (c) 2022-2023 PktSurf <smlinux@pktsurf.in>
@ -43,10 +43,45 @@ elif ((BASH_VERSINFO[0] < 4)) ; then
err "Bldpkg requires a minimum of GNU bash shell version 4 to run"
fi
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below.
# This output goes into package build summary.
commencedate=$(date '+%a, %d %b %Y, %T')
getbuildfileanddir() {
srcdir="$PWD"
buildfile="${srcdir##*/}.SMBuild"
}
# Function to error out the build in absence of a build file
nopackagebuildfileerror() {
err "No package build file to source from!
Was expecting '$buildfile' to be present inside this directory '$PWD'.
Try -f <build_file> if your build file has a different name (Not recommended)
If you want to autobuild packages, use -a"
}
startdate() {
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below.
# This output goes into package build summary.
commencedate=$(date '+%a, %d %b %Y, %T')
}
htmloutput() {
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
if [[ $htmloutput = 1 ]] ; then
if [[ -n $autobuildmode ]] ; then
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package $currentpkgnumber / $totalpkgnumber: <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
else
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
fi
touch "$parenttmp/BUILDING"
fi
}
# Function to generate help message
help() {
cat << EOF
@ -127,71 +162,78 @@ validatebldfile() {
source $buildfile
fi
for reqvars in app version build homepage desc requires ; do
[[ ! ${!reqvars} ]] && err "Required variable '$reqvars' is not set in $buildfile!"
done
# Check if 'Maintainer' comment exists
if ! grep -q "^# Maintainer" "$buildfile" ; then
err "Please provide a Maintainer name and email as a comment at the top of the build file"
# Validate $app
elif ! echo "$app" | grep -E -q '[a-z0-9-]+'; then
err "Only lower case, numeric characters and dash allowed in the 'app' variable in the build file."
# Validate $version
elif ! echo "$version" | grep -E -q '[a-z0-9.]+'; then
err "Only lower case, numeric characters and a period allowed in the 'version' variable in the build file."
# Validate $homepage
elif ! echo "$homepage" | grep -E -q '(https|http|ftp)://[^"]+' ; then
err "Invalid URL in the 'homepage' variable in the build file."
# Validate $desc using bash shell's ability to count variable length
elif [[ ${#desc} -gt 100 ]] ; then
err "Package description should not exceed 100 characters in the build file."
# Check if prepbuilddir() function exists in the build file
elif ! grep -q '^prepbuilddir() {' "$buildfile" ; then
err "'prepbuilddir()' function does not exist in your build file."
# Check if build() function exists in the build file
elif ! grep -q '^build() {' "$buildfile" ; then
err "'build()' function does not exist in your build file."
fi
# Validate the download variable separately because it's optional
if [[ -n $download ]] ; then
if ! echo "$download" | grep -E -q '(https|http|ftp)://[^"]+' ; then
err "Invalid URL in the 'download' variable in the build file."
# Check to prevent a package from being built on an unsupported CPU architecture
if [[ -n $apparch ]] ; then
local detectedarch="$(uname -m)"
if [[ $apparch != $detectedarch ]] ; then
info "'$app' not supported on your current CPU '$detectedarch'. Build aborted."
buildskipped=1
return 0
fi
fi
# Check integrity of files defined in sha512sums variable which is expected
# in nearly every single package build file
if [[ -z $sha512sums ]] ; then
err "Please run 'bldpkg -g' to add sha512sums into '$buildfile'!"
else
eval sums=\"\$sha512sums\"
info "Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
err "Checksums failed to match!"
fi
if [[ -z $buildskipped ]] ; then
for reqvars in app version build homepage desc requires ; do
[[ ! ${!reqvars} ]] && err "Required variable '$reqvars' is not set in $buildfile!"
done
unset IFS
# Check if 'Maintainer' comment exists
if ! grep -q "^# Maintainer" "$buildfile" ; then
err "Please provide a Maintainer name and email as a comment at the top of the build file"
# Validate $app
elif ! echo "$app" | grep -E -q '[a-z0-9-]+'; then
err "Only lower case, numeric characters and dash allowed in the 'app' variable in the build file."
# Validate $version
elif ! echo "$version" | grep -E -q '[a-z0-9.]+'; then
err "Only lower case, numeric characters and a period allowed in the 'version' variable in the build file."
# Validate $homepage
elif ! echo "$homepage" | grep -E -q '(https|http|ftp)://[^"]+' ; then
err "Invalid URL in the 'homepage' variable in the build file."
# Validate $desc using bash shell's ability to count variable length
elif [[ ${#desc} -gt 100 ]] ; then
err "Package description should not exceed 100 characters in the build file."
# Check if prepbuilddir() function exists in the build file
elif ! grep -q '^prepbuilddir() {' "$buildfile" ; then
err "'prepbuilddir()' function does not exist in your build file."
# Check if build() function exists in the build file
elif ! grep -q '^build() {' "$buildfile" ; then
err "'build()' function does not exist in your build file."
fi
# Validate the download variable separately because it's optional
if [[ -n $download ]] ; then
if ! echo "$download" | grep -E -q '(https|http|ftp)://[^"]+' ; then
err "Invalid URL in the 'download' variable in the build file."
fi
fi
# Check integrity of files defined in sha512sums variable which is expected
# in nearly every single package build file
if [[ -z $sha512sums ]] ; then
err "Please run 'bldpkg -g' to add sha512sums into '$buildfile'!"
fi
fi
}
# Function to error out the build in absence of a build file
nopackagebuildfileerror() {
err "No package build file to source from!
Was expecting '$buildfile' to be present inside this directory '$PWD'.
Try -f <build_file> if your build file has a different name (Not recommended)
If you want to autobuild packages, use -a"
verifychecksums() {
eval sums=\"\$sha512sums\"
info "Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
err "Checksums failed to match!"
fi
done
unset IFS
}
# Function to validate MAKEFLAGS passed on by getopts
validatemakeflags() {
local makeflags="$1"
local makeflags0="${makeflags/-j/}"
@ -201,6 +243,7 @@ validatemakeflags() {
}
# Function for applying patches to the build in a more efficient manner
# For use inside a package build file
applypatch() {
# Take patch file name as the first argument
local patchfile="$1"
@ -215,6 +258,7 @@ applypatch() {
# Get relative path of the patch file
local relativepath=${patchfile##*/}
info "Applying patch '$relativepath'.."
# We use if/else to determine if the patch applied successfully
if ! patch -p1 < "$patchfile" ; then
err "Failed to apply patch file '$patchfile'"
@ -232,20 +276,6 @@ inarray() {
return 1
}
# Function to prevent a package from compiling on an unsupported architecture
compileonlyfor() {
# usage: compileonlyfor <arch>
# will cause compilation to exit with 0 if uname -m does not match <arch>
local archname="$(uname -m)"
local archargument="$1"
if [[ $archname != $archargument ]]; then
info "'$app' not supported on your current CPU '$archname'. Build aborted."
buildskipped=1
return 0
fi
}
# Function to validate compilers.
# Usage: compilertestfile "$CC" "$CFLAGS" cc-test.c cc-test
compilertestfile() {
@ -302,7 +332,7 @@ sccacheprocess() {
}
# Function to remove old package directories and make new ones.
# To be invoked inside a package build file.
# For use inside a package build file.
mkandenterbuilddir() {
# Define $pkgdocs. Rest is defined in bldpkg.conf.
@ -319,7 +349,7 @@ mkandenterbuilddir() {
}
# Function to fix permissions inside the build directory
# To be invoked inside a package build file.
# For use inside a package build file.
fixbuilddirpermissions() {
info "Fixing permissions in the newly-created build directory..."
chown -R root.root .
@ -347,12 +377,7 @@ runtime() {
fi
}
getbuildfileanddir() {
srcdir="$PWD"
buildfile="${srcdir##*/}.SMBuild"
}
# Generate and insert sha512sums into the build file
# Function to generate and insert sha512sums into the build file
genchecksum() {
getbuildfileanddir
@ -387,8 +412,11 @@ genchecksum() {
exit 0
}
# Function to generate and insert a runit service file into a staging directory.
# For use inside a package build file
# Usage: preprunitservice -s chrony -d -f
preprunitservice() {
# Usage: preprunitservice -s chrony -d -f
unset OPTIND OPTARG
while getopts ':dfs:' option; do
case "$option" in
d) downfile=1 ;; # Add a 'down' file
@ -407,8 +435,7 @@ preprunitservice() {
[[ -n $downfile ]] && touch "$pkg/etc/service/$servicefile/down"
[[ -n $finishfile ]] && touch "$pkg/etc/service/$servicefile/finish"
# Unset OPTIND and OPTARG to avoid problems if getopts is used again in the future
unset OPTIND OPTARG
return 0
}
# Function to validate symlinks.
@ -448,6 +475,7 @@ EOF
fi
}
# Function to extract a successfully built package inside the source directory
extractinfo() {
info "Extracting package installer inside $srcdir/test..."
mkdir -p "$srcdir/test"
@ -455,16 +483,18 @@ extractinfo() {
info "'$app' package installer file successfully extracted"
}
# Function to prompt a user to extract a successfully built package inside the
# the source directory
promptuser() {
# Extract package at the end of a build if autoextract is set to 1
if [[ $autoextract = 1 ]] && [[ -z $autobuild ]] && [[ -n $newpkglocation ]] ; then
if [[ $autoextract = 1 ]] && [[ -z $autobuildmode ]] && [[ -n $newpkglocation ]] ; then
extractinfo
fi
# Prompt the user at the end of a build whether to extract contents of a newly-built installer
# into a subdirectory called "test" inside the package source directory the build was manually initiated from.
# Has no effect on autobuilds since they are simply installed right away.
if [[ $extractprompt = 1 ]] && [[ -z $autobuild ]] && [[ -n $newpkglocation ]] ; then
if [[ $extractprompt = 1 ]] && [[ -z $autobuildmode ]] && [[ -n $newpkglocation ]] ; then
read -r -p "[NOTIFY] Would you like the package installer of '$app-$version' to be extracted in your current directory '$srcdir' for examination? (y/N) " yn
case "$yn" in
Y|y) info "Wise Choice :-)"
@ -475,7 +505,7 @@ promptuser() {
# Prompt the user at the end of a successful build whether to install the newly created package.
# Has no effect on autobuilds because packages there are installed automatically.
if [[ $installprompt = 1 ]] && [[ -z $autobuild ]] && [[ -n $newpkglocation ]] ; then
if [[ $installprompt = 1 ]] && [[ -z $autobuildmode ]] && [[ -n $newpkglocation ]] ; then
read -r -p "[NOTIFY] Would you like the package installer of '$app-$version' to be installed/upgraded onto your system? (y/N) " yn
case "$yn" in
Y|y) info "Wise choice :-) " ;
@ -483,10 +513,6 @@ promptuser() {
*) info "Nope? Alright." ;;
esac
fi
if [[ $pkgstatus = 0 ]] ; then
return 0
fi
}
# This function will set the interrupt variable so prepbuildoutput can output the right build status
@ -506,7 +532,7 @@ interruptoutput() {
}
# Function to perform post-compile tasks.
# To be invoked inside a package build file.
# For use inside a package build file.
mkfinalpkg() {
# Now we attempt to split the total time we'll get when making the summary into two times: compile
@ -560,16 +586,18 @@ EOF
# Compress and link manpages
if [[ -d share/man ]]; then
info "Compressing and linking man pages..."
( cd "share/man"
for manpagedir in $(find . -type d -name "man*") ; do
( cd $manpagedir
for eachpage in $( find . -type l -maxdepth 1) ; do
ln -s $( readlink $eachpage ).gz $eachpage.gz
rm $eachpage
done
gzip -9 ./*.? >/dev/null 2>&1 || true
)
done
(
cd "share/man"
for manpagedir in $(find . -type d -name "man*") ; do
(
cd $manpagedir
for eachpage in $( find . -type l -maxdepth 1) ; do
ln -s $( readlink $eachpage ).gz $eachpage.gz
rm $eachpage
done
gzip -9 ./*.? >/dev/null 2>&1 || true
)
done
)
fi
@ -645,7 +673,6 @@ EOF
--xform 'sx^\./\(.\)x\1x' \
--show-stored-names | "$compressor" "$compressoropts" > "$newpkglocation"
pkgstatus=$?
#export pkgstatus
echo
info "SMLinux package '$app-$version-$arch-$build.$pkgext' successfully generated in $pkgdest."
@ -686,11 +713,17 @@ EOF
fi
fi
cd "$srcdir"
# Delete the build directory if preservebuilddir is set to 0
[[ $preservebuilddir = 0 ]] && rm -rf "$tmp"
# Delete the package staging directory if preservepackagedir is set to 0
[[ $preservepackagedir = 0 ]] && rm -rf "$pkg"
if [[ $pkgstatus = 0 ]] ; then
return 0
fi
}
findarchivefiles() {
@ -749,7 +782,7 @@ prepbuildoutput() {
fi
# Determine the build type
if [[ -n $autobuild ]]; then
if [[ -n $autobuildmode ]]; then
# We are using the autobuild system
buildsys="Autobuild"
else
@ -876,16 +909,12 @@ EOF
}
stage0prep() {
# Check if $parenttmp is set and is a directory
# Check if $parenttmp is set and is a directory and can be written into
if [[ -z $parenttmp ]] ; then
err "parenttmp variable not set in bldpkg.conf."
elif [[ ! -d $parenttmp ]] ; then
err "parenttmp variable set to '$parenttmp' in bldpkg.conf is not a directory."
fi
# Attempt to write to the $parenttmp directory. This directory is used for everything related to the
# build process outside the source directory $srcdir
if ! touch "$parenttmp/.parenttmpwritetest" ; then
elif ! touch "$parenttmp/.parenttmpwritetest" ; then
err "Parent temp directory '$parenttmp' is not writable!"
else
# Discard the test file
@ -1019,7 +1048,7 @@ stage1prep() {
fi
CXXFLAGS="$CFLAGS"
export hostdist builddist CC CXX CFLAGS CXXFLAGS MAKEFLAGS
export CC CXX CFLAGS CXXFLAGS MAKEFLAGS
# Validate available compilers. Quotes are important while passing C/CXXFLAGS
compilertestfile "$CC" "$CFLAGS" cc-test.c cc-test
@ -1086,14 +1115,17 @@ rustc-wrapper = "/bin/sccache"'
# If verbosebuild is set in bldpkg.conf or if verbosity is set to 1 from getopts, set V and
# VERBOSE environment variables for make and cmake build systems to pick up.
if [[ $verbosebuild = 1 ]] || [[ $getoptsverbosebuild = 1 ]] ; then
V=1
VERBOSE=1
else
V=0
VERBOSE=0
if [[ -z $disableverbosebuild ]] ; then
if [[ $verbosebuild = 1 ]] || [[ $getoptsverbosebuild = 1 ]] ; then
V=1
VERBOSE=1
else
V=0
VERBOSE=0
fi
export V VERBOSE
fi
export V VERBOSE
# If $noautoconfsite is unset in an individual package build file, export CONFIG_SITE variable into the build
# environment for a package's configure script to pickup. Most autoconf-compatible configure scripts will
@ -1142,6 +1174,8 @@ autobuild() {
# If the defined section does not exist, abort
if [[ ! -d $section ]] ; then
err "Section directory '$section' not found!"
elif [[ ! -f "$section/.buildlist.$section" ]] ; then
err "Section build list file '$section/.buildlist.$section' not found!"
fi
cd $section
@ -1181,15 +1215,13 @@ autobuild() {
fi
rm -f $packfiletemppath $dirfiletemppath
if [[ ! -f .buildlist.$section ]] ; then
err "Section build list file '.buildlist.$section' not found!"
fi
while IFS="" read -r package || [[ -n $package ]] ; do
unset app build version buildskipped
(
SECONDS=0
currentpkgnumber="$(grep -Ewn "^$package" .buildlist.$section | cut -d: -f 1)"
# We need this variable to switch back to the section directory inside the loop
startdate
currentpwd="$PWD"
cd $package
@ -1198,36 +1230,36 @@ autobuild() {
getbuildfileanddir
validatebldfile "$buildfile"
# Check if package installer exists or is installed on the system
# If the package installer does not exist in the set pkg destination, build it
if [ ! -f $pkgdest/$app-$version-*-$build.* ] ; then
# Store the source directory path the build was initiated from
if [[ -z $buildskipped ]] ; then
# Check if package installer exists or is installed on the system
# If the package installer does not exist in the set pkg destination, build it
if [ ! -f $pkgdest/$app-$version-*-$build.* ] ; then
info "Building package '$app' version '$version' ..."
htmloutput
stage0prep
verifychecksums
prepbuilddir
stage1prep
# Presume that the build file name will match the name of the parent directory
# unless otherwise overridden using -f <buildfile>
stage0prep
touch "$parenttmp/BUILDING"
prepbuilddir
stage1prep
if [[ -z $buildskipped ]] ; then
trap "prepbuildoutput" EXIT
build
fi
# If the package is not installed in the system, install it
if [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
# If the package is not installed in the system, install it
if [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
upgradepkg --install-new $pkgdest/$app-$version-*-$build.*
else
info "'$app-$version' already installed, skipping it"
fi
elif [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
upgradepkg --install-new $pkgdest/$app-$version-*-$build.*
else
info "'$app-$version' already installed, skipping it"
info "Already built '$app-$version', skipping it"
fi
elif [ ! -f /var/log/packages/$app-$version-*-$build ] ; then
upgradepkg --install-new $pkgdest/$app-$version-*-$build.*
else
info "Already built '$app-$version', skipping it"
fi
cd $currentpwd
)
done < ".buildlist.$section"
cd ..
@ -1236,72 +1268,59 @@ autobuild() {
}
manualbuild() {
trap "prepbuildoutput" EXIT
startdate
trap "interruptoutput" INT
# Display the package and its version we are building or resuming
if [[ -z $resumepkgbuild ]] ; then
info "Building package '$app' version '$version' ..."
else
info "Resuming build of package '$app' version '$version' ..."
fi
stage0prep
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
if [[ $htmloutput = 1 ]] ; then
if [[ -n $autobuild ]] ; then
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package $currentpkgnumber / $totalpkgnumber: <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
else
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
if [[ -z $buildskipped ]] ; then
if [[ -z $resumepkgbuild ]] ; then
info "Building package '$app' version '$version' ..."
else
info "Resuming build of package '$app' version '$version' ..."
fi
htmloutput
stage0prep
touch "$parenttmp/BUILDING"
fi
# If $tmp exists, get the path to the $.app-$version.extraction.complete file
[[ -d $tmp ]] && buildresumepath="$(find $tmp -type f -name .$app-$version.extraction.complete)"
# If $tmp exists, get the path to the $.app-$version.extraction.complete file
[[ -d $tmp ]] && buildresumepath="$(find $tmp -type f -name .$app-$version.extraction.complete)"
# If the above file exists, $resumepkgbuild and $autobuild are unset
# and $autoresumepkgbuild is set to 1 in bldpkg.conf, prompt the user
if [[ -f $buildresumepath ]] && [[ -z $resumepkgbuild ]] && [[ $autoresumepkgbuild = 1 ]] && [[ -z $autobuild ]]; then
read -r -p "[NOTIFY] Would you like to resume building? " yn
case "$yn" in
N|n|No|no) info "Nope? Alright." ;
# Prompt the user
if [[ -f $buildresumepath ]] && [[ -z $resumepkgbuild ]] && [[ $autoresumepkgbuild = 1 ]] ; then
read -r -p "[NOTIFY] Would you like to resume building? " yn
case "$yn" in
N|n|No|no) info "Nope? Alright." ;
unset resumepkgbuild ;;
*) info "Wise choice :-) "
resumepkgbuild=1 ;;
esac
fi
esac
fi
# If $resumepkgbuild variable is not set in getopts, only then execute prepbuilddir variable
[[ -z $resumepkgbuild ]] && prepbuilddir
# If $resumepkgbuild variable is not set in getopts, only then execute prepbuilddir variable
if [[ -z $resumepkgbuild ]] ; then
verifychecksums
prepbuilddir
fi
stage1prep
stage1prep
trap "prepbuildoutput" EXIT
build
# If $resumepkgbuild is set either in getopts or from the user prompt above, execute mkandenterbuilddir
# function to enter the build directory. This is being done because mkandenterbuilddir is part of prepbuilddir
# function in the build file and ignoring prepbuilddir will not cause mkandenterbuilddir to be invoked
# separately unless the build system is told to.
if [[ -n $resumepkgbuild ]] ; then
mkandenterbuilddir
# If $resumepkgbuild is set either in getopts or from the user prompt above, execute mkandenterbuilddir
# function to enter the build directory. This is being done because mkandenterbuilddir is part of prepbuilddir
# function in the build file and ignoring prepbuilddir will not cause mkandenterbuilddir to be invoked
# separately unless the build system is told to.
if [[ -n $resumepkgbuild ]] ; then
mkandenterbuilddir
# fixbuilddirpermissions places a file ".$app-$version.extraction.complete". Only resume the build if that file exists
if [[ ! -f $buildresumepath ]] ; then
err "Can't resume build of '"$app"'! Are you certain the source was extracted completely?"
else
cd ${buildresumepath%/*}
# fixbuilddirpermissions places a file ".$app-$version.extraction.complete". Only resume the build if that file exists
if [[ ! -f $buildresumepath ]] ; then
err "Can't resume build of '"$app"'! Are you certain the source was extracted completely?"
else
cd ${buildresumepath%/*}
fi
fi
fi
build
}
# Source the main configuration file holding all necessary values
@ -1326,7 +1345,8 @@ while getopts ':adef:ghj:o:rstvx' option; do
e) extractprompt=0;
autoextract=1 ;; # Automatically extract the final pkg installer inside user's PWD
f) setbuildfile="$OPTARG" ;;
g) genchecksum ;;
g) genchecksum=1 ;
[[ -z $autobuildmode ]] && genchecksum ;;
h) help ;;
j) custommakeflags="$OPTARG" ;;
o) origbuildfile="$OPTARG" ;;
@ -1334,7 +1354,7 @@ while getopts ':adef:ghj:o:rstvx' option; do
s) showsummary=1 ;; # Show build summary at the end of the build irrespective of the build status
t) tmpfs=1 ;;
v) getoptsverbosebuild=1 ;;
x) set -xv ;; # Invoke bash's -x option for command tracing
x) set -x ;; # Invoke bash's -x option for command tracing
*) help ;;
esac
done
@ -1369,6 +1389,19 @@ elif [[ $OPTIND -gt 1 ]] ; then
fi
if [[ $autobuildmode = 1 ]] ; then
# Disallow certain variables that may be passed on by getopts
if [[ -n $autoextract ]] ; then
err "-e option not allowed in autobuild mode"
elif [[ -n $genchecksum ]] ; then
err "-g option not allowed in autobuild mode"
elif [[ -n $origbuildfile ]] ; then
err "-o option not allowed in autobuild mode"
elif [[ -n $setbuildfile ]] ; then
err "-f option not allowed in autobuild mode"
elif [[ -n $resumepkgbuild ]] ; then
err "-r option not allowed in autobuild mode"
fi
autobuild
elif [[ -z $autobuildmode ]] ; then
@ -1403,7 +1436,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
err "Build file '$setbuildfile' not found!"
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f $buildfile ]] ; then
if ! validatebldfile "$buildfile" ; then
err "'$buildfile' validation failed!"
@ -1411,14 +1444,11 @@ elif [[ $OPTIND -gt 1 ]] ; then
manualbuild
fi
# If even that file is not found, throw an error and exit
# If even that file is not found, throw an error and exit
else
nopackagebuildfileerror
fi
fi
fi
# Unset OPTIND and OPTARG
unset OPTIND OPTARG
# End of script